AFK_Password_PW = "123"
local HelpHeaders = {}
AFKPassword = CreateFrame("FRAME","AFKPassword",WorldFrame)
AFKPassword:SetWidth(GetScreenWidth()) 
AFKPassword:SetHeight(GetScreenHeight())
AFKPassword:SetPoint("CENTER", 0, 0)
AFKPassword:SetBackdrop({ bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16, insets = { left = 3, right = 3, top = 3, bottom = 3 } })
AFKPassword:SetBackdropColor(0.2,0.2,0.2,1)
AFKPassword:SetBackdropBorderColor(0.2,0.1,0.1,1)
AFKPassword:SetScript("OnShow", function() 
    UIParent:Hide() 
    HelpHeaders = {} 
    AFKPassword_Text3:SetText("")
    ErrorPassword_editBox:SetText("") 
    end)
AFKPassword:EnableMouse(true)
AFKPassword:Hide()

AFK_Password_EditBoxs = CreateFrame("EditBox", "AFK_Password_EditBox", AFKPassword, "InputBoxTemplate")
AFK_Password_EditBox:SetWidth(300)
AFK_Password_EditBox:SetHeight(50)
AFK_Password_EditBox:SetJustifyH("CENTER")
AFK_Password_EditBox:SetTextInsets(0,6,0,0)
AFK_Password_EditBox:SetPoint("CENTER", 0, 0)
AFK_Password_EditBox:SetText("XXXXXXXXXXXX")
AFK_Password_EditBox:SetPassword(true)
AFK_Password_EditBox:SetScript("OnEnterPressed", function() AFKPassword_UnlockClick() end)

AFKPassword:CreateFontString("AFKPassword_Text", "ARTWORK", "SubZoneTextFont")
AFKPassword_Text:SetText("Wow Locked")
AFKPassword_Text:SetPoint("TOP", AFKPassword, "TOP", 0, -150)

AFKPassword:CreateFontString("AFKPassword_Text4", "ARTWORK", "GameFontNormal")
AFKPassword_Text4:SetText("AFKPassword by Nyll")
AFKPassword_Text4:SetPoint("BOTTOM", AFKPassword, "BOTTOM", 0, 0)

AFKPassword:CreateFontString("AFKPassword_Text2", "ARTWORK", "SubZoneTextFont")
AFKPassword_Text2:SetText("Please Enter Password")
AFKPassword_Text2:SetPoint("TOP", AFKPassword, "TOP", 0, -200)

AFKPassword:CreateFontString("AFKPassword_Text3", "ARTWORK", "QuestDifficulty_Impossible")
AFKPassword_Text3:SetPoint("CENTER", AFKPassword, "CENTER", 0, 30)

AFK_Password_Unlock = CreateFrame("Button", "AFK_Password_Unlock", AFKPassword, "OptionsButtonTemplate")
AFK_Password_Unlock:SetWidth(85)
AFK_Password_Unlock:SetText("Unlock")
AFK_Password_Unlock:SetPoint("CENTER", AFKPassword, 0, -63)
AFK_Password_Unlock:SetScript("OnClick", function() AFKPassword_UnlockClick() end)

 
ErrorPassword = CreateFrame("Frame", "ErrorPassword", AFKPassword)
ErrorPassword:SetWidth(350)
ErrorPassword:SetHeight(100)
ErrorPassword:SetPoint("CENTER", 0, -200)
ErrorPassword:SetFrameStrata("DIALOG")
ErrorPassword:SetBackdrop({
  bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
  edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", 
  edgeSize = 16,
  insets = { left = 3, right = 3, top = 3, bottom = 3 }
})
ErrorPassword:SetBackdropColor(0.2,0.2,0.2,1)
ErrorPassword:SetBackdropBorderColor(0.2,0.1,0.1,1)
ErrorPassword:SetScale(.85)
ErrorPassword:EnableMouse(true)

ErrorPassword_scrollArea = CreateFrame("ScrollFrame", "ErrorPassword_scrollArea", ErrorPassword, "UIPanelScrollFrameTemplate")
ErrorPassword_scrollArea:SetPoint("TOPLEFT", ErrorPassword, "TOPLEFT", 15, -15)
ErrorPassword_scrollArea:SetPoint("BOTTOMRIGHT", ErrorPassword, "BOTTOMRIGHT", -34, 15)

ErrorPassword_editBox = CreateFrame("EditBox", "ErrorPassword_editBox", ErrorPassword)
ErrorPassword_editBox:SetMultiLine(true)
ErrorPassword_editBox:SetMaxLetters(99999)
ErrorPassword_editBox:SetAutoFocus(false)
ErrorPassword_editBox:SetFontObject(ChatFontNormal)
ErrorPassword_editBox:SetWidth(400)
ErrorPassword_editBox:SetHeight(270)
ErrorPassword_editBox:SetScript("OnTextChanged", function() 
    local text = table.concat(HelpHeaders, "\n")
    ErrorPassword_editBox:SetText(text)
end)
ErrorPassword_scrollArea:SetScrollChild(ErrorPassword_editBox)


function AddErrprBox(value)
    table.insert(HelpHeaders, date(string.format("[%%H:%%M:%%S]", GetTime()*1000)).." "..value)
    local text = table.concat(HelpHeaders, "\n")
    ErrorPassword_editBox:SetText(text)
end


function AFKPassword_UnlockClick()
    if (Base(AFK_Password_EditBox:GetText()) == AFK_Password_PW) then
        AFKPassword:Hide()
        UIParent:Show()
    else 
        AFKPassword_Text3:SetText("Invalid Password")
        AddErrprBox("Invalid Password")
    end  
end

function Show_Lock_Frame()
    AFKPassword:Show()
end

function AFK_Password_System(msg)
    local cmd, value = msg:match("^(%S*)%s*(.-)$")
    if (cmd == "set" and value ~= "") then
        AFK_Password_PW = Base(value)
        print("You new password "..value)
    elseif (cmd == "on") then
        Show_Lock_Frame()
    else print("Addon Command:\n/pw set - Установить новый пароль\n/pw on - Включить защиту")
    end    
end

SlashCmdList["AFK_PASSWORD_COMMANDS"] = AFK_Password_System
SLASH_AFK_PASSWORD_COMMANDS1 = "/pw"

print("AFKPassword загружен.\nКоманды аддона /pw")

-- Lua 5.1+ base64 v3.0 (c) 2009 by Alex Kloss <alexthkloss@web.de>
-- licensed under the terms of the LGPL2

local b='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'

function Base(data)
    return ((data:gsub('.', function(x) 
        local r,b='',x:byte()
        for i=8,1,-1 do r=r..(b%2^i-b%2^(i-1)>0 and '1' or '0') end
        return r;
    end)..'0000'):gsub('%d%d%d?%d?%d?%d?', function(x)
        if (#x < 6) then return '' end
        local c=0
        for i=1,6 do c=c+(x:sub(i,i)=='1' and 2^(6-i) or 0) end
        return b:sub(c+1,c+1)
    end)..({ '', '==', '=' })[#data%3+1])
end

